{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL, KOLMonthCalendar {$IFNDEF KOL_MCK}, mirror, Classes, Controls, mckControls, mckObjs, Graphics,  MCKMonthCalendar, mckCtrls {$ENDIF (place your units here->)};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TForm1 = class; PForm1 = TForm1; {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLForm1: TKOLForm;
    GroupBox1: TKOLGroupBox;
    cbMouseMove: TKOLCheckBox;
    cbMouseDown: TKOLCheckBox;
    cbSelChange: TKOLCheckBox;
    cbSelect: TKOLCheckBox;
    KOLProject1: TKOLProject;
    Memo1: TKOLMemo;
    MonthCalendar1: TKOLMonthCalendar;
    ListBox1: TKOLListBox;
    lbStart: TKOLLabel;
    lbEnd: TKOLLabel;
    Label1: TKOLLabel;
    GroupBox2: TKOLGroupBox;
    MonthCalendar2: TKOLMonthCalendar;
    Label2: TKOLLabel;
    GroupBox3: TKOLGroupBox;
    MonthCalendar3: TKOLMonthCalendar;
    cbWeekNumbers: TKOLCheckBox;
    cbShowToday: TKOLCheckBox;
    cbShowTodayCircle: TKOLCheckBox;
    ComboBox1: TKOLComboBox;
    Label3: TKOLLabel;
    DateTimePicker1: TKOLDateTimePicker;
    DateTimePicker2: TKOLDateTimePicker;
    Label4: TKOLLabel;
    Label5: TKOLLabel;
    Label6: TKOLLabel;
    ComboBox2: TKOLComboBox;
    Label7: TKOLLabel;
    DateTimePicker3: TKOLDateTimePicker;
    procedure MonthCalendar1MouseMove(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure MonthCalendar1MouseDown(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure MonthCalendar1SelChange(Sender: PObj);
    procedure MonthCalendar1Select(Sender: PControl; const SelStart,
      SelEnd: TDateTime);
    procedure GroupBox1EraseBkgnd(Sender: PControl; DC: HDC);
    procedure MonthCalendar1EraseBkgnd(Sender: PControl; DC: HDC);
    procedure MonthCalendar2Select(Sender: PControl; const SelStart,
      SelEnd: TDateTime);
    procedure MonthCalendar2GetMonthInfo(Sender: PControl; Month: Cardinal;
      var MonthBoldInfo: Cardinal);
    procedure MonthCalendar2MouseDown(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure cbWeekNumbersClick(Sender: PObj);
    procedure cbShowTodayClick(Sender: PObj);
    procedure cbShowTodayCircleClick(Sender: PObj);
    procedure ComboBox1Change(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure DateTimePicker1Change(Sender: PObj);
    procedure ComboBox2Change(Sender: PObj);
    procedure DateTimePicker3Change(Sender: PObj);
  private
    HitCode1:  Integer;
    HitDate1: TDateTime;
    procedure MonthCalendar1HitTest(const Mouse: TMouseEventData);
    procedure AddLog(const Str: String);
    procedure DecodeHitTestCode;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

var
  MemoScrollPos: Integer = 0;


var
  ColorShemeAr: Array[0..2,0..5] of TColor = (
    (0,0,0,0,0,0),
    (clGreen,clMoneyGreen,clBlack,clGreen,clSkyBlue,clWhite),
    (clMaroon,clFuchsia,clBlack,clRed,clWhite,clRed)
  );

procedure TForm1.AddLog(const Str: String);
begin
  if MemoScrollPos = 0 then Memo1.Add(Str)
  else Memo1.Add(#13#10+Str);
  Memo1.Perform(EM_LINESCROLL,0,MemoScrollPos);
  Inc(MemoScrollPos);
end;

procedure TForm1.MonthCalendar1HitTest;
begin
  HitCode1 := MonthCalendar1.HitTest(Mouse.X,Mouse.Y,HitDate1);
  DecodeHitTestCode();
end;

procedure TForm1.MonthCalendar1MouseMove(Sender: PControl;
  var Mouse: TMouseEventData);
begin
  MonthCalendar1HitTest(Mouse);
  if not cbMouseMove.Checked then Exit;
  AddLog('MouseMove  = '+Int2Hex(HitCode1,8)+','+Date2StrFmt('dd.MM.yy',HitDate1));
end;

procedure TForm1.MonthCalendar1MouseDown(Sender: PControl;
  var Mouse: TMouseEventData);
begin
  MonthCalendar1HitTest(Mouse);
  if not cbMouseDown.Checked then Exit;
  AddLog('MouseDown = '+Int2Hex(HitCode1,8)+','+Date2StrFmt('dd.MM.yy',HitDate1));
end;

procedure TForm1.MonthCalendar1SelChange(Sender: PObj);
begin
  if not cbSelChange.Checked then Exit;
  AddLog('SelChange');
end;

procedure TForm1.MonthCalendar1Select(Sender: PControl; const SelStart,
  SelEnd: TDateTime);
begin
  lbStart.Caption := Date2StrFmt('dd.MM.yy',SelStart);
  if Trunc(SelStart) <> Trunc(SelEnd) then lbEnd.Caption := Date2StrFmt('dd.MM.yy',SelEnd)
  else lbEnd.Caption := '';
  if not cbSelect.Checked then Exit;
  AddLog('Select = Start:'+lbStart.Caption+
   ',End:'+Date2StrFmt('dd.MM.yy',SelEnd));
end;

procedure TForm1.GroupBox1EraseBkgnd(Sender: PControl; DC: HDC);
  procedure Line(const FromX,FromY,ToX,ToY: Integer);
//  var
//    iX,iY: Integer;
  begin
    with GroupBox1.Canvas^ do begin
      Pen.Color := clSkyBlue;//clSilver;
      MoveTo(FromX,FromY);
      LineTo(ToX,ToY);
      {
      iX := Integer(FromX=ToX);
      iY := Integer(FromY=ToY);
      Pen.Color := clWhite;
      MoveTo(FromX+iX,FromY+iY);
      LineTo(ToX+iX,ToY+iY);
      }
    end;
  end;
begin
  GroupBox1.Canvas.Handle := DC;
  with GroupBox1.Canvas^ do begin
    FillRect(GroupBox1.Canvas.ClipRect);
    Line(Memo1.Left-1,8,Memo1.Left-1,GroupBox1.Height-2);
    Line(MonthCalendar1.BoundsRect.Right, ListBox1.Top-1, Memo1.Left-1, ListBox1.Top-1);
    Line(MonthCalendar1.BoundsRect.Right, ListBox1.BoundsRect.Bottom+1, Memo1.Left-1, ListBox1.BoundsRect.Bottom+1);
  end;
end;

procedure TForm1.MonthCalendar1EraseBkgnd(Sender: PControl; DC: HDC);
begin
//
end;

procedure TForm1.DecodeHitTestCode;
var
  S: String;
begin
  ListBox1.Clear;
  ListBox1.Add('HIT AREA:');
  Case HitCode1 of
    MCHT_NOWHERE          : S := 'MCHT_NOWHERE';
    MCHT_TITLE            : S := 'MCHT_TITLE';
    MCHT_CALENDAR         : S := 'MCHT_CALENDAR';
    MCHT_TODAYLINK        : S := 'MCHT_TODAYLINK';
    MCHT_TITLEMONTH       : S := 'MCHT_TITLEMONTH       ';
    MCHT_TITLEYEAR        : S := 'MCHT_TITLEYEAR        ';
    MCHT_TITLEBTNNEXT     : S := 'MCHT_TITLEBTNNEXT     ';
    MCHT_TITLEBTNPREV     : S := 'MCHT_TITLEBTNPREV     ';
    MCHT_CALENDARDATE     : S := 'MCHT_CALENDARDATE     ';
    MCHT_CALENDARDATENEXT : S := 'MCHT_CALENDARDATENEXT ';
    MCHT_CALENDARDATEPREV : S := 'MCHT_CALENDARDATEPREV ';
    MCHT_CALENDARDAY      : S := 'MCHT_CALENDARDAY      ';
    MCHT_CALENDARWEEKNUM  : S := 'MCHT_CALENDARWEEKNUM  '
  else S := ''
  end;
  ListBox1.Add(S);
  ListBox1.Add('HIT DATE:');
  ListBox1.Add(Date2StrFmt('dd.MM.yy',HitDate1));
end;

procedure TForm1.MonthCalendar2Select(Sender: PControl; const SelStart,
  SelEnd: TDateTime);
begin
  with MonthCalendar2^ do begin
    SetBoldDays([0,1,0]);
  end;
end;

var
  BoldDays: Array[1..12] of LongWord;

procedure TForm1.MonthCalendar2GetMonthInfo(Sender: PControl;
  Month: Cardinal; var MonthBoldInfo: Cardinal);
begin
  MonthBoldInfo :=  BoldDays[Month];
end;

procedure TForm1.MonthCalendar2MouseDown(Sender: PControl;
  var Mouse: TMouseEventData);
var
  D: TDateTime;
  ST: TSystemTime;
  Ret: Integer;
  function PrevMonth(Month: Integer): Integer;
  begin
    Result := Month-1;
    if Result = 0 then Result := 12;
  end;
  function NextMonth(Month: Integer): Integer;
  begin
    Result := Month+1;
    if Result > 12 then Result := 1;
  end;
begin
  Case Mouse.Button of
    mbLeft: begin
      Ret := MonthCalendar2.HitTest(Mouse.X,Mouse.Y,D);
      if (Ret and $FFFFF) = MCHT_CALENDARDATE then begin
        DateTime2SystemTime(D,ST);
        if ST.wMonth in [1..12] then begin
          BoldDays[ST.wMonth] := BoldDays[ST.wMonth] or (1 shl (ST.wDay-1));
          MonthCalendar2.SetBoldDays([BoldDays[PrevMonth(ST.wMonth)],
            BoldDays[ST.wMonth],BoldDays[NextMonth(ST.wMonth)]]);
        end;
      end;
    end;
    mbRight: begin
      Ret := MonthCalendar2.HitTest(Mouse.X,Mouse.Y,D);
      if (Ret and $FFFFF) = MCHT_CALENDARDATE then begin
        DateTime2SystemTime(D,ST);
        if ST.wMonth in [1..12] then begin
          BoldDays[ST.wMonth] := BoldDays[ST.wMonth] and not (1 shl (ST.wDay-1));
          MonthCalendar2.SetBoldDays([BoldDays[PrevMonth(ST.wMonth)],
            BoldDays[ST.wMonth],BoldDays[NextMonth(ST.wMonth)]]);
        end;
      end;
    end;

  end;
end;

procedure TForm1.cbWeekNumbersClick(Sender: PObj);
begin
  MonthCalendar3.WeekNumbers := cbWeekNumbers.Checked;
  MonthCalendar3.AdjustSize;
end;

procedure TForm1.cbShowTodayClick(Sender: PObj);
begin
  MonthCalendar3.ShowToday := cbShowToday.Checked;
  MonthCalendar3.AdjustSize;
end;

procedure TForm1.cbShowTodayCircleClick(Sender: PObj);
begin
  MonthCalendar3.ShowTodayCircle := cbShowTodayCircle.Checked;
  MonthCalendar3.AdjustSize;
end;

procedure TForm1.ComboBox1Change(Sender: PObj);
begin
  MonthCalendar3.MaxSelectRange := Str2Int(ComboBox1.Text);
  MonthCalendar3.AdjustSize;
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
  DateTimePicker1.Date := MonthCalendar3.MinDate;
  DateTimePicker2.Date := MonthCalendar3.MaxDate;
  DateTimePicker3.Date := MonthCalendar3.Today;
  ColorShemeAr[0,0] := MonthCalendar3.BackColor;
  ColorShemeAr[0,1] := MonthCalendar3.MonthBackColor;
  ColorShemeAr[0,2] := MonthCalendar3.TextColor;
  ColorShemeAr[0,3] := MonthCalendar3.TitleBackColor;
  ColorShemeAr[0,4] := MonthCalendar3.TitleTextColor;
  ColorShemeAr[0,5] := MonthCalendar3.TrailingTextColor;
end;

procedure TForm1.DateTimePicker1Change(Sender: PObj);
begin
  MonthCalendar3.SetRange(DateTimePicker1.Date,DateTimePicker2.Date);
  DateTimePicker1.Date := MonthCalendar3.MinDate;
  DateTimePicker2.Date := MonthCalendar3.MaxDate;
  DateTimePicker3.Date := MonthCalendar3.Today;
end;

procedure TForm1.ComboBox2Change(Sender: PObj);
var
  Idx: Integer;
begin
  Idx := COmboBox2.CurIndex;
  if Idx in [0..2] then begin
    MonthCalendar3.BackColor := ColorShemeAr[Idx,0];
    MonthCalendar3.MonthBackColor := ColorShemeAr[Idx,1];
    MonthCalendar3.TextColor := ColorShemeAr[Idx,2];
    MonthCalendar3.TitleBackColor := ColorShemeAr[Idx,3];
    MonthCalendar3.TitleTextColor := ColorShemeAr[Idx,4];
    MonthCalendar3.TrailingTextColor := ColorShemeAr[Idx,5];
  end;
  if Idx = 2 then MonthCalendar3.Font.FontName := 'Comic Sans MS'
  else MonthCalendar3.Font.FontName := 'Tahoma';
  MonthCalendar3.AdjustSize;
end;

procedure TForm1.DateTimePicker3Change(Sender: PObj);
begin
  MonthCalendar3.Today := DateTimePicker3.Date;
  DateTimePicker3.Date := MonthCalendar3.Today;
end;

end.







