unit MCKMonthCalendar;

interface
{$I KOLDEF.INC}

uses
  Windows, KOL, Classes, Messages, Forms, SysUtils, mirror,
  mckCtrls, Graphics, Controls,
//////////////////////////////////////////////////
     {$IFDEF _D6orHigher}                       //
     DesignIntf, DesignEditors, DesignConst,    //
     Variants,                                  //
     {$ELSE}                                    //
//////////////////////////////////////////////////
     DsgnIntf,
//////////////////////////////////////////////////////////
     {$ENDIF}                                           //
     KOLMonthCalendar;

type

  TKOLMonthCalendar = class(TKOLControl)
  private
    fHideEvent: TOnEvent;
    fHideBool: Boolean;
    fHideInt: Integer;
    fHideStr: String;
    fOnSelChange: TOnEvent;
    fOnGetMInfo: TOnGetMonthInfo;
    fOnSelect: TOnSelect;
    fOptions: TMonthCalendarOptions;
    fAutoSize: Boolean;
    fWeekNumbers: Boolean;
    fShowTodayCircle: Boolean;
    fShowToday: Boolean;
    fFirstDayOfWeek: TCalDayOfWeek;
    fMultiSelect: Boolean;
    fToday: Integer;
    fDate: Integer;
    fUniCode: Boolean;
    fColors: Array[0..5] of TColor;
    fDefColors: Array[0..5] of TColor;
    fMonthDelta: Integer;
    fDefKOLCtrl: PMonthCalendar;
    fMaxSelectRange: Integer;
    fMinDate: Integer;
    fMaxDate: Integer;
    bColorChanged: Boolean;
    procedure SetOnGetMInfo(const Value: TOnGetMonthInfo);
    procedure SetOnSelect(const Value: TOnSelect);
    procedure SetSelChange(const Value: TOnEvent);
    procedure SetOptions(const Value: TMonthCalendarOptions);
    procedure SetAutoSize2(const Value: Boolean);
    procedure SetWeekNumbers(const Value: Boolean);
    procedure SetShowToday(const Value: Boolean);
    procedure SetShowTodayCircle(const Value: Boolean);
    procedure SetFirstDay(const Value: TCalDayOfWeek);
    procedure SetMultiSelect(const Value: Boolean);
    procedure SetDate(const Value: TDate);
    procedure SetToday(const Value: TDate);
    function  GetDate: TDate;
    function  GetToday: TDate;
    procedure SetUniCode(const Value: Boolean);
    procedure SetMonthDelta(const Value: Integer);
    function GetColorByIdx(const Index: Integer): TColor;
    procedure SetColorByIdx(const Index: Integer; const Value: TColor);
    function GetDefColorByIdx(const Index: Integer): TColor;
    procedure SetMaxSelRange(const Value: Integer);
    procedure SetMaxDate(const Value: TDate);
    procedure SetMinDate(const Value: TDate);
    function GetMaxDate: TDate;
    function GetMinDate: TDate;
  protected
    function  AdditionalUnits: string; override;
//?    function TabStopByDefault: Boolean; override;
    function SetupParams( const AName, AParent: String ): String; override;
    function P_SetupParams( const AName, AParent: String; var nparams: Integer ): String; override;
    procedure SetupLast(SL: TStringList; const AName, AParent, Prefix: String); override;
    procedure P_SetupLast(SL: TStringList; const AName, AParent, Prefix: String); override;
    procedure AssignEvents( SL: TStringList; const AName: String ); override;
    function P_AssignEvents( SL: TStringList; const AName: String;
      CheckOnly: Boolean ): Boolean; override;
    procedure SetupConstruct( SL: TStringList; const AName, AParent, Prefix: String ); override;
    procedure P_SetupConstruct( SL: TStringList; const AName, AParent, Prefix: String ); override;
    procedure CreateKOLControl(Recreating: boolean); override;
    procedure KOLControlRecreated; override;
    procedure SetupFirst( SL: TStringList; const AName, AParent, Prefix: String ); override;
    procedure P_SetupFirst( SL: TStringList; const AName, AParent, Prefix: String ); override;
    property DefBackColor: TColor index 0 read GetDefColorByIdx;
    property DefMonthBackColor:  TColor index 1 read GetDefColorByIdx;
    property DefTextColor:       TColor index 2 read GetDefColorByIdx;
    property DefTitleBackColor:  TColor index 3 read GetDefColorByIdx;
    property DefTitleTextColor:  TColor index 4 read GetDefColorByIdx;
    property DefTrailingTextColor:  TColor index 5 read GetDefColorByIdx;
  public
    function Pcode_Generate: Boolean; override;
    constructor Create( AOwner: TComponent ); override;
    procedure Change; override;
    procedure Loaded; override;
  published
    property OnClick: TOnEvent read fHideEvent; // Hide
    property TabStop: Boolean read fHideBool;
    property MinHeight: Integer read fHideInt;
    property MinWidth: Integer read fHideInt;
    property MaxHeight: Integer read fHideInt;
    property MaxWidth: Integer read fHideInt;
    property Caption: String read fHideStr;
    property AutoSize: Boolean read fAutoSize write SetAutoSize2;
    property Options: TMonthCalendarOptions read fOptions write SetOptions;
    property WeekNumbers: Boolean read fWeekNumbers write SetWeekNumbers;
    property ShowToday: Boolean read fShowToday write SetShowToday;
    property ShowTodayCircle: Boolean read fShowTodayCircle write SetShowTodayCircle;
    property MultiSelect: Boolean read fMultiSelect write SetMultiSelect;
    property FirstDayOfWeek: TCalDayOfWeek read fFirstDayOfWeek write SetFirstDay;
    property OnSelChange: TOnEvent read fOnSelChange write SetSelChange;
    property OnGetMonthInfo: TOnGetMonthInfo read fOnGetMInfo write SetOnGetMInfo;
    property OnSelect: TOnSelect read fOnSelect write SetOnSelect;
    property UniCodeFormat: Boolean read fUniCode write SetUniCode;
    property Date: TDate read GetDate write SetDate;
    property Today: TDate read GetToday write SetToday;
    property BackColor: TColor index 0 read GetColorByIdx write SetColorByIdx;
    property MonthBackColor:  TColor index 1 read GetColorByIdx write SetColorByIdx;
    property TextColor:       TColor index 2 read GetColorByIdx write SetColorByIdx;
    property TitleBackColor:  TColor index 3 read GetColorByIdx write SetColorByIdx;
    property TitleTextColor:  TColor index 4 read GetColorByIdx write SetColorByIdx;
    property TrailingTextColor:  TColor index 5 read GetColorByIdx write SetColorByIdx;
    property MonthDelta:  Integer read fMonthDelta write SetMonthDelta;
    property MaxSelectRange: Integer read fMaxSelectRange write SetMaxSelRange;
    property MinDate: TDate read GetMinDate write SetMinDate;
    property MaxDate: TDate read GetMaxDate write SetMaxDate;
    property Color: TColor index 0 read GetColorByIdx write SetColorByIdx;
  end;

procedure Register;

implementation


procedure Register;
begin
  RegisterComponents('KOL Win32', [TKOLMonthCalendar]);
end;


{ TKOLMonthCalendar }

procedure TKOLMonthCalendar.AssignEvents(SL: TStringList;
  const AName: String);
begin
  inherited;
    DoAssignEvents( SL, AName, [ 'OnSelChange','OnSelect' ],
                             [ @OnSelChange, @OnSelect] );
end;

constructor TKOLMonthCalendar.Create(AOwner: TComponent);
begin
  inherited;
  fOptions := [mcoToday,mcoTodayCircle];
  fDefKOLCtrl := NewMonthCalendar(fKOLParentCtrl,fOptions);
//  Color := clWhite;
  Font.Color := clBlack;
  fDefKOLCtrl.AdjustSize;
  fColors[0] := fDefKOLCtrl.BackColor;
  fColors[1] := fDefKOLCtrl.MonthBackColor;
  fColors[2] := fDefKOLCtrl.TextColor;
  fColors[3] := fDefKOLCtrl.TitleBackColor;
  fColors[4] := fDefKOLCtrl.TitleTextColor;
  fColors[5] := fDefKOLCtrl.TrailingTextColor;
  Move(fColors[0],fDefColors[0],SizeOf(fDefColors));
  fMonthDelta := fDefKOLCtrl.MonthDelta;
  fMaxSelectRange := 7;//fDefKOLCtrl.MaxSelectRange;
  Width := 180;//fDefKOLCtrl.Width;
  DefaultWidth := Width;
  Height := 180;//fDefKOLCtrl.Height;
  fShowToday := TRUE;      //fDefKOLCtrl.ShowToday;
  fShowTodayCircle := TRUE;//fDefKOLCtrl.ShowTodayCircle;
  fWeekNumbers := FALSE;   //fDefKOLCtrl.WeekNumbers;
  fFirstDayOfWeek := dowLocaleDefault;
  DefaultHeight := Height;
  fAutoSize := FALSE;
  fToday := 0;//Now;
  fDate := 0;//fToday;
end;
{
function TKOLMonthCalendar.GenerateTransparentInits: String;
begin
  Result := inherited GenerateTransparentInits;
end;
}
function TKOLMonthCalendar.P_AssignEvents(SL: TStringList;
  const AName: String; CheckOnly: Boolean): Boolean;
begin
  Result := FALSE; //TODO
end;

function TKOLMonthCalendar.P_SetupParams(const AName, AParent: String;
  var nparams: Integer): String;
begin
  //TODO
end;

function TKOLMonthCalendar.Pcode_Generate: Boolean;
begin
  Result := FALSE; //TODO!!!
end;

function TKOLMonthCalendar.SetupParams(const AName,
  AParent: String): String;
var S: String;
begin
  S := '';
  if mcoWeekNumbers in Options then S := S + ', mcoWeekNumbers';
  if mcoTodayCircle in Options then S := S + ', mcoTodayCircle';
  if mcoToday in Options then S := S + ', mcoToday';
  if mcoMultiSelect in Options then S := S + ', mcoMultiSelect';
  Delete( S, 1, 1 );
  Result := AParent + ', [' + S + ']';
end;

procedure TKOLMonthCalendar.SetOnGetMInfo(const Value: TOnGetMonthInfo);
begin
  fOnGetMInfo := Value;
  Change;
end;

procedure TKOLMonthCalendar.SetOnSelect(const Value: TOnSelect);
begin
  fOnSelect := Value;
  Change;
end;

procedure TKOLMonthCalendar.SetSelChange(const Value: TOnEvent);
begin
  fOnSelChange := Value;
  Change;
end;

function TKOLMonthCalendar.AdditionalUnits: string;
begin
  Result := ', KOLMonthCalendar';
end;

procedure TKOLMonthCalendar.P_SetupConstruct(SL: TStringList; const AName,
  AParent, Prefix: String);
begin
  inherited;
  //TODO
end;

procedure TKOLMonthCalendar.SetupConstruct(SL: TStringList; const AName,
  AParent, Prefix: String);
var
  S: String;
begin
  S := GenerateTransparentInits;
  SL.Add( Prefix + AName + ' := PMonthCalendar( New' + TypeName + '( '
          + SetupParams( AName, AParent ) + ' )' + S + ');' );
  if Name <> '' then
  begin
    SL.Add( '   {$IFDEF USE_NAMES}' );
    SL.Add( Prefix + AName + '.Name := ''' + Name + ''';' );
    SL.Add( '   {$ENDIF}' );
  end;
end;

procedure TKOLMonthCalendar.SetOptions(const Value: TMonthCalendarOptions);
begin
  fOptions := Value;
  fWeekNumbers := mcoWeekNumbers in fOptions;
  fShowToday := mcoToday in fOptions;
  fShowTodayCircle := mcoTodayCircle in fOptions;
  fMultiSelect := mcoMultiSelect in fOptions;
  Change;
end;

procedure TKOLMonthCalendar.P_SetupLast(SL: TStringList; const AName,
  AParent, Prefix: String);
begin
  inherited;
  //TODO
end;

procedure TKOLMonthCalendar.SetupLast(SL: TStringList; const AName,
  AParent, Prefix: String);
begin
  inherited;
  if AutoSize then SL.Add( Prefix + AName + '.AdjustSize;' );
end;

procedure TKOLMonthCalendar.SetAutoSize2(const Value: Boolean);
begin
  fAutoSize := Value;
  if fAutoSize then begin
      PMonthCalendar(FKolCtrl).AdjustSize;
      BoundsRect := FKOLCtrl.BoundsRect;
  end;
  Change;
end;

procedure TKOLMonthCalendar.CreateKOLControl(Recreating: boolean);
begin
  FKOLCtrl := PControl(NewMonthCalendar (KOLParentCtrl,Options ));
  Assert(DbgLog('Create!'));
end;

procedure TKOLMonthCalendar.KOLControlRecreated;
begin
  inherited;
end;

procedure TKOLMonthCalendar.SetWeekNumbers(const Value: Boolean);
begin
  fWeekNumbers := Value;
  if Value then fOptions := fOptions+[mcoWeekNumbers]
  else fOptions := fOptions-[mcoWeekNumbers];
  Change;
end;

procedure TKOLMonthCalendar.SetShowToday(const Value: Boolean);
begin
  fShowToday := Value;
  if Value then fOptions := fOptions+[mcoToday]
  else fOptions := fOptions-[mcoToday];
  Change;
end;

procedure TKOLMonthCalendar.SetShowTodayCircle(const Value: Boolean);
begin
  fShowTodayCircle := Value;
  if Value then fOptions := fOptions+[mcoTodayCircle]
  else fOptions := fOptions-[mcoTodayCircle];
  Change;
end;

procedure TKOLMonthCalendar.SetFirstDay(const Value: TCalDayOfWeek);
begin
  fFirstDayOfWeek := Value;
  Change;
end;

procedure TKOLMonthCalendar.Change;
begin
  inherited;
  Assert(DbgLog('Change!'));
  if Assigned(FKOLCtrl) then begin
    PMonthCalendar(FKOLCtrl).WeekNumbers := WeekNumbers;
    PMonthCalendar(FKOLCtrl).ShowTodayCircle := ShowTodayCircle;
    PMonthCalendar(FKOLCtrl).ShowToday := ShowToday;
    PMonthCalendar(FKOLCtrl).FirstDayOfWeek := FirstDayOfWeek;
    if fDate <> 0 then
      PMonthCalendar(FKOLCtrl).Date := fDate + VCLDate0;
    if fToday <> 0 then
      PMonthCalendar(FKOLCtrl).Today := fToday + VCLDate0;
    PMonthCalendar(FKOLCtrl).UniCodeFormat := Integer(fUniCode);
    PMonthCalendar(FKOLCtrl).BackColor := BackColor;
    PMonthCalendar(FKOLCtrl).MonthBackColor := MonthBackColor;
    PMonthCalendar(FKOLCtrl).TextColor := TextColor;//Font.Color;
    PMonthCalendar(FKOLCtrl).TitleBackColor := TitleBackColor;
    PMonthCalendar(FKOLCtrl).TitleTextColor := TitleTextColor;
    PMonthCalendar(FKOLCtrl).TrailingTextColor := TrailingTextColor;
    PMonthCalendar(FKOLCtrl).MonthDelta := MonthDelta;
    {
    if fAutoSize then begin
      PMonthCalendar(FKolCtrl).AdjustSize;
      BoundsRect := FKOLCtrl.BoundsRect;
    end;
    }
  end;
  if (not bColorChanged) and (TextColor <> Font.Color) then
    TextColor := Font.Color;
  bColorChanged := FALSE;
end;

procedure TKOLMonthCalendar.SetMultiSelect(const Value: Boolean);
begin
  fMultiSelect := Value;
  if Value then fOptions := fOptions+[mcoMultiSelect]
  else fOptions := fOptions-[mcoMultiSelect];
  Change;
end;

procedure TKOLMonthCalendar.SetDate(const Value: TDate);
begin
  fDate := Trunc(Value);
  Change;
end;

procedure TKOLMonthCalendar.SetToday(const Value: TDate);
begin
  fToday := Trunc(Value);
  Change;
end;

function TKOLMonthCalendar.GetDate: TDate;
begin
  //if Assigned (FKOLCtrl) and (not fDateMCK) then
  //  fDate := PMonthCalendar(FKOLCtrl).Date - VCLDate0;
  Result := fDate;
end;

function TKOLMonthCalendar.GetToday: TDate;
begin
  //if Assigned (FKOLCtrl) and (not fTodayMCK) then
  //  fToday := PMonthCalendar(FKOLCtrl).Today - VCLDate0;
  Result := fToday
end;

procedure TKOLMonthCalendar.SetUniCode(const Value: Boolean);
begin
  fUniCode := Value;
  Change;
end;

procedure TKOLMonthCalendar.SetMonthDelta(const Value: Integer);
begin
  fMonthDelta := Value;
  Change;
end;

procedure TKOLMonthCalendar.P_SetupFirst(SL: TStringList; const AName,
  AParent, Prefix: String);
begin
  inherited;
  //TODO
end;

procedure TKOLMonthCalendar.SetupFirst(SL: TStringList; const AName,
  AParent, Prefix: String);
const
  CalDay2Str : Array[TCalDayOfWeek] of String = ('dowMonday', 'dowTuesday',
    'dowWednesday', 'dowThursday', 'dowFriday', 'dowSaturday', 'dowSunday',
    'dowLocaleDefault');
begin
  inherited;
  DoAssignEvents( SL, AName, [ 'OnGetMonthInfo'],[ @OnGetMonthInfo ] );
//  Assert(DbgLog('Setup First!' +Int2Hex(Integer(fDefKOLCtrl),8)));

  if FirstDayOfWeek <> dowLocaleDefault then
    SL.Add( Prefix + AName + '.FirstDayOfWeek := ' +  CalDay2Str[fFirstDayOfWeek] +';');

  if fDate <> 0 then
    SL.Add( Prefix + AName + '.Date := ' +  Int2Str(Trunc(fDate)+VCLDate0 ) +';');

  if fToday <> 0 then
    SL.Add( Prefix + AName + '.Today := ' +  Int2Str(Trunc(fToday)+VCLDate0 ) + ';');

  if fUniCode then
    SL.Add( Prefix + AName + '.UniCodeFormat:= 1;');

  if DefBackColor <> BackColor then
    SL.Add( Prefix + AName + '.BackColor := ' +  Color2Str(Integer(BackColor)) +';');

  if DefMonthBackColor <> MonthBackColor then
    SL.Add( Prefix + AName + '.MonthBackColor := ' +  Color2Str(Integer(MonthBackColor))+';');

  if DefTextColor <> TextColor then
    SL.Add( Prefix + AName + '.TextColor := ' +  Color2Str(Integer(TextColor))+';');

  if DefTitleBackColor <> TitleBackColor then
    SL.Add( Prefix + AName + '.TitleBackColor := ' +  Color2Str(Integer(TitleBackColor))+';');

  if DefTitleTextColor <> TitleTextColor then
    SL.Add( Prefix + AName + '.TitleTextColor := ' +  Color2Str(Integer(TitleTextColor))+';');

  if DefTrailingTextColor <> TrailingTextColor then
    SL.Add( Prefix + AName + '.TrailingTextColor := ' +  Color2Str(Integer(TrailingTextColor))+';');

  if MonthDelta <> 1 then
    SL.Add( Prefix + AName + '.MonthDelta := ' +  Int2Str(MonthDelta)+';');

  if MaxSelectRange <> 7 then
    SL.Add( Prefix + AName + '.MaxSelectRange := ' +  Int2Str(MaxSelectRange)+';');

  if (fMaxDate <> 0) then
    SL.Add( Prefix + AName + '.MaxDate := ' +  Int2Str(fMaxDate+VCLDate0)+';');

  if (fMinDate <> 0) then
    SL.Add( Prefix + AName + '.MinDate := ' +  Int2Str(fMinDate+VCLDate0)+';');

end;

function TKOLMonthCalendar.GetColorByIdx(const Index: Integer): TColor;
begin
  Result := fColors[Index];
end;

procedure TKOLMonthCalendar.SetColorByIdx(const Index: Integer;
  const Value: TColor);
begin
  fColors[Index] := Value;
  Case Index of
//    1: Color := Value; // Color <=> MonthBackColor
    2: Font.Color := Value; // Font.Color <=> TextColor
  end;
  bColorChanged := TRUE;
  Change;
end;

function TKOLMonthCalendar.GetDefColorByIdx(const Index: Integer): TColor;
begin
  Result := fDefColors[Index];
end;

procedure TKOLMonthCalendar.SetMaxSelRange(const Value: Integer);
begin
  fMaxSelectRange := Value;
  Change;
end;

procedure TKOLMonthCalendar.SetMaxDate(const Value: TDate);
begin
  fMaxDate := Trunc(Value);
  Change;
end;

procedure TKOLMonthCalendar.SetMinDate(const Value: TDate);
begin
  fMinDate := Trunc(Value);
  Change;
end;

function TKOLMonthCalendar.GetMaxDate: TDate;
begin
  Result := fMaxDate;
end;

function TKOLMonthCalendar.GetMinDate: TDate;
begin
  Result := fMinDate;
end;

procedure TKOLMonthCalendar.Loaded;
begin
  inherited;
//  Color  := MonthBackColor;
  Font.Color := TextColor;
end;

end.

